<id>
RSS on Board Index for YaBB 2.4 (BoardPass Compatible Mod)
</id>

<version>
1.0
</version>

<mod info>
Description
-----------
Adds RSS links for each board and category on Board Index

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
3) Upload boardrss.png to the default template directory in binary mode.

Files to edit
-------------
Admin/ManageBoards.pl
Admin/ManageCats.pl
Admin/ManageTemplates.pl
Admin/ModList.pl 
Languages/English/Admin.lng
Sources/BoardIndex.pl
Sources/Load.pl
Templates/default/BoardIndex.template
Templates/yabb21/BoardIndex.template

Version History
---------------
V0.1 - First release - 2nd November 2009
V0.2 - Fixed small markup error in 2.1 template and changed mod file to be compatible with other mods - 4th November 2009
V0.3 - Added to ManageTemplates.pl - 8th November 2009
V1.0 - Changed settings so that they are configured for each board and category individually and fixed issue with RSS image being visible to users without permission to view the board - 9th January 2010
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
		$brdpic   = "";
</search for>

<add after>
		$brdrssch = ""; ### RSS on Board Index Mod ###
</add after>

<search for>
		if (${$uid.$id}{'attperms'} == 1) { $attch    = qq~ checked="checked"~; }
</search for>

<add after>
		if (${$uid.$id}{'brdrss'} == 1)   { $brdrssch = qq~ checked="checked"~; } ### RSS on Board Index Mod ###
</add after>

<search for>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="text" id="pic$i" name="pic$i" value="$boardpic" size="50" maxlength="255"$brdpic /></td>
  </tr><tr>
</search for>

<add after>
    <td class="windowbg" width="25%" align="left"><label for="brdrss$i"><b>$admin_txt{'brdrss1'}:</b></label></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="brdrss$i" id="brdrss$i" value="1"$brdrssch /> <label for="brdrss$i"><span class="small">$admin_txt{'brdrss3'}</span></label></td>
  </tr><tr>
</add after>

<search for>
		if ($FORM{"zero$i"} eq '') { $FORM{"zero$i"} = 0; }
</search for>

<add before>
		if ($FORM{"brdrss$i"} eq '') { $FORM{"brdrss$i"} = 0; } ### RSS on Board Index Mod ###
</add before>

<search for>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}|$FORM{\"paswwr$i\"}|$encryptopass\n");
</search for>

<replace>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}|$FORM{\"paswwr$i\"}|$encryptopass|$FORM{\"brdrss$i\"}\n");
</replace>

<search for>
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender,$brdpasswr,$brdpassw) = split(/\|/, $oldcontrols[$cnt]);
</search for>

<replace>
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender,$brdpasswr,$brdpassw,$brdrss) = split(/\|/, $oldcontrols[$cnt]);
</replace>

<search for>
				$oldcontrols[$cnt] = qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender|$brdpasswr|$brdpassw~;
</search for>

<replace>
				$oldcontrols[$cnt] = qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender|$brdpasswr|$brdpassw|$brdrss~;
</replace>

<edit file>
Admin/ManageCats.pl
</edit file>

<search for>
				($curcatname, $catperms, $catallowcol, $catimage) = split(/\|/, $catinfo{"$catid"});
</search for>

<replace>
				($curcatname, $catperms, $catallowcol, $catimage, $catrss) = split(/\|/, $catinfo{"$catid"});
</replace>

<search for>
				if ($catallowcol eq '' || $catallowcol eq '1') { $allowChecked = 'checked="checked"'; }
				else { $allowChecked = ''; }
</search for>

<add after>
				### RSS on Board Index Mod Start ###
				if ($catrss == 1) { $catrssch = ' checked="checked"'; }
				else { $catrssch = ''; }
				### RSS on Board Index Mod End ###
</add after>

<search for>
    <td class="windowbg2" align="center" rowspan="3"><select multiple="multiple" name="catperms$i" size="5">$catperms</select><br /><span class="small">$admin_txt{'14'}</span></td>
    <td class="windowbg2" align="center" rowspan="3"><input type="checkbox" $allowChecked name="allowcol$i" /></td>
</search for>

<replace>
    <td class="windowbg2" align="center" rowspan="4"><select multiple="multiple" name="catperms$i" size="5">$catperms</select><br /><span class="small">$admin_txt{'14'}</span></td>
    <td class="windowbg2" align="center" rowspan="4"><input type="checkbox" $allowChecked name="allowcol$i" /></td>
</replace>

<search for>
    <td class="windowbg2"><br /><input type="text" name="catimage$i" value="$catimage" size="40" />~ . ($catimage ? qq~<br /><br  /><img src="$catimage" alt="" border="0" />~ : '') . qq~<br /><br /></td>
  </tr>~;
</search for>

<replace>
    <td class="windowbg2"><br /><input type="text" name="catimage$i" value="$catimage" size="40" />~ . ($catimage ? qq~<br /><br  /><img src="$catimage" alt="" border="0" />~ : '') . qq~<br /><br /></td>
  </tr><tr>
    <td class="windowbg" align="right" valign="middle"><label for="catrss$i"><b>$admin_txt{'brdrss1'}:</b></label></td>
    <td class="windowbg2"><br /><input type="checkbox" name="catrss$i" id="catrss$i"$catrssch /> <label for="catrss$i"><span class="small">$admin_txt{'brdrss2'}</span></label><br /><br /></td>
  </tr>~;
</replace>

<search for>
		if ($FORM{"allowcol$i"} eq 'on') { $FORM{"allowcol$i"} = 1; }
		else { $FORM{"allowcol$i"} = 0; }
</search for>

<add after>

		### RSS on Board Index Mod Start ### 
		if ($FORM{"catrss$i"} eq 'on') { $FORM{"catrss$i"} = 1; }
		else { $FORM{"catrss$i"} = 0; }
		### RSS on Board Index Mod End ###
</add after>

<search for>
		$catinfo{"$id"} = qq~$cname|$FORM{"catperms$i"}|$FORM{"allowcol$i"}|$FORM{"catimage$i"}~;
</search for>

<replace>
		$catinfo{"$id"} = qq~$cname|$FORM{"catperms$i"}|$FORM{"allowcol$i"}|$FORM{"catimage$i"}|$FORM{"catrss$i"}~;
</replace>

<edit file>
Admin/ManageTemplates.pl
</edit file>

<search for>
		$templateblock =~ s/({|<)yabb new(}|>)/$tempnew/g;
</search for>

<add after>
		$templateblock =~ s/({|<)yabb boardrss(}|>)//g; ### RSS on Board Index Mod ###
</add after>

<search for>
	$boardindex_template =~ s/({|<)yabb catimage(}|>)//g;
</search for>

<add after>
	$boardindex_template =~ s/({|<)yabb catrss(}|>)//g; ### RSS on Board Index Mod ###
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$mod_boardrss = "RSS on Board Index|Derek Barnstorm|Adds RSS links for each board and category on Board Index|1.0|9th January 2010";
	push (@installed_mods, "$mod_boardrss");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'extendedprofiles' => 'Use Extended Profiles?<br /><span class="small">If enabled an additional item called "Profile Fields" will be shown on left side. There you can add functions to the users proflies.<br />Leave this unchecked if you don\'t use this feature to save server load!</span>',
</search for>

<add after>
### RSS on Board Index Mod Start ###
'brdrss1' => 'RSS',
'brdrss2' => 'Check to show RSS Feed for this category on the Board Index.<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>Note:</b> Only relevant if RSS is enabled.',
'brdrss3' => 'Check to show RSS Feed for this board on the Board Index.<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>Note:</b> Only relevant if RSS is enabled.',
### RSS on Board Index Mod End ###
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		my ($catname, $catperms, $catallowcol, $catimage) = split(/\|/, $catinfo{"$catid"});
</search for>

<replace>
		my ($catname, $catperms, $catallowcol, $catimage, $catrss) = split(/\|/, $catinfo{"$catid"});
</replace>

<search for>
		$templatecat = $catheader;
</search for>

<add before>
	    ### RSS on Board Index Mod Start ###
	    if (!$rss_disabled && $catrss) {
		    $rss_catlink = qq~<a href="$scripturl?action=RSSrecent;catselect=$catid" target="_blank"><img src="$imagesdir/boardrss.png" border="0" alt="$maintxt{'rssfeed'} - $catname" title="$maintxt{'rssfeed'} - $catname" style="vertical-align: middle;" /></a>~;
	    } else {
	        $rss_catlink = '';
	    }
	    ### RSS on Board Index Mod End ###
	    
</add before>

<search for>
		$templatecat =~ s/({|<)yabb catimage(}|>)/$tmpcatimg/g;
</search for>

<add after>
		$templatecat =~ s/({|<)yabb catrss(}|>)/$rss_catlink/g; ### RSS on Board Index Mod ###
</add after>

<search for>
					$lastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
				}
</search for>

<add after>

				### RSS on Board Index Mod Start ###
				if (!$rss_disabled) {
			        my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
	                if (&AccessCheck($curboard, '', $boardperms) eq "granted" && ${$uid.$curboard}{'brdrss'} == 1) {
		                $rss_boardlink = qq~<a href="$scripturl?action=RSSboard;board=$curboard" target="_blank"><img src="$imagesdir/boardrss.png" border="0" alt="$maintxt{'rssfeed'} - $boardname" title="$maintxt{'rssfeed'} - $boardname" style="vertical-align: middle;" /></a>~;
	                } else {
	                    $rss_boardlink = '';
	                }
	            }
	            ### RSS on Board Index Mod End ###
</add after>

<search for>
				$templateblock =~ s/({|<)yabb new(}|>)/$new/g;
</search for>

<add after>
				$templateblock =~ s/({|<)yabb boardrss(}|>)/$rss_boardlink/g; ### RSS on BoardIndex Mod ###
</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw) = split(/\|/, $boardline);
</search for>

<replace>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw, $cntbrdrss) = split(/\|/, $boardline);
</replace>

<search for>
			'brdpassw'  => $brdpassw,);
</search for>

<replace>
			'brdpassw'  => $brdpassw,
			'brdrss'    => $cntbrdrss,);
</replace>

<search for>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw) = split(/\|/, $boardline);
</search for>

<replace>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw, $cntbrdrss) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$brdpasswr|$brdpassw\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$brdpasswr|$brdpassw|$cntbrdrss\n");
</replace>

<search for>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw) = split(/\|/, $boardline);
</search for>

<replace>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw, $cntbrdrss) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$brdpasswr|$brdpassw\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$brdpasswr|$brdpassw|$cntbrdrss\n");
</replace>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
		{yabb catimage} {yabb catlink}
</search for>

<replace>
		{yabb catimage} {yabb catrss} {yabb catlink}
</replace>

<search for>
		{yabb new} <a name="{yabb boardanchor}" href="{yabb boardurl}"><b>{yabb boardname}</b></a><br />
</search for>

<replace>
		{yabb new} {yabb boardrss} <a name="{yabb boardanchor}" href="{yabb boardurl}"><b>{yabb boardname}</b></a><br />
</replace>

<search for>
		{yabb new} <a name="{yabb boardanchor}" href="{yabb boardurl}"><b>{yabb boardname}</b></a><br />
</search for>

<replace>
		{yabb new} {yabb boardrss} <a name="{yabb boardanchor}" href="{yabb boardurl}"><b>{yabb boardname}</b></a><br />
</replace>

<edit file>
Templates/yabb21/BoardIndex.template
</edit file>

<search for>
<tr><td colspan="5" class="catbg" height="18" ><yabb catimage> <yabb catlink></td></tr>
</search for>

<replace>
<tr><td colspan="5" class="catbg" height="18" ><yabb catimage> <yabb catrss> <yabb catlink></td></tr>
</replace>

<search for>
	<td class="windowbg2" width="55%" align="left"><a name="<yabb boardanchor>" id="<yabb boardanchor>" href="<yabb boardurl>"><yabb boardpic><b><yabb boardname></b></a><br /><yabb boarddesc><br /><div class="small" style="font-style:italic;"><yabb moderators></div></td>
</search for>

<replace>
	<td class="windowbg2" width="55%" align="left"><a href="<yabb boardurl>"><yabb boardpic></a> <yabb boardrss> <a name="<yabb boardanchor>" id="<yabb boardanchor>" href="<yabb boardurl>"><b><yabb boardname></b></a><br /><yabb boarddesc><br /><div class="small" style="font-style:italic;"><yabb moderators></div></td>
</replace>

<search for>
	<td class="windowbg2" width="55%" align="left"><a name="<yabb boardanchor>" id="<yabb boardanchor>" href="<yabb boardurl>"><yabb boardpic><b><yabb boardname></b></a><br /><yabb boarddesc><br /><div class="small" style="font-style:italic;"><yabb moderators></div></td>
</search for>

<replace>
	<td class="windowbg2" width="55%" align="left"><a href="<yabb boardurl>"><yabb boardpic></a> <yabb boardrss> <a name="<yabb boardanchor>" id="<yabb boardanchor>" href="<yabb boardurl>"><b><yabb boardname></b></a><br /><yabb boarddesc><br /><div class="small" style="font-style:italic;"><yabb moderators></div></td>
</replace>
